package com.Conquistadores.App;

import com.Conquistadores.App.R;

import android.app.Activity;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Bundle;
import android.view.KeyEvent;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;

/**
 * Pantalla de inicio para empezar a jugar. Se comprueba si la conexin a Internet y
 * el GPS estn operativos.
 * 
 * @author Fco. Javier Quero Castrillo <xavifuenla@gmail.com>
 * 
 */
public class Conquistadores extends Activity implements OnClickListener{
	private Button botonEmpezar;
	
    /** Called when the activity is first created. */
    @Override
    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
        setContentView(R.layout.conquistadores);
        botonEmpezar = (Button)this.findViewById(R.id.botonEmpezar);
        botonEmpezar.setOnClickListener(this);
    }
    
	@Override
    public void onClick(View v){
    	if(botonEmpezar.isPressed()){
    		boolean internetActivo = Utilidades.estadoInternet(this);
    		if (internetActivo){
        		boolean gpsActivo = Utilidades.estadoGPS(this);
    			if (gpsActivo){
        			Intent i = new Intent(Conquistadores.this, PartidaListar.class);
        			this.startActivity(i);
    			}else{
        			String titulo = getString(R.string.aviso);
        			String msg = getString(R.string.noGPS);
        			int icon = R.drawable.ic_dialog_warning;
        			alertConexion(icon,titulo,msg);
    			}
    		}else{
    			String titulo = getString(R.string.aviso);
    			String msg = getString(R.string.noConexion);
    			int icon = R.drawable.ic_dialog_warning;
    			alertConexion(icon,titulo,msg);
    		}
    	}
    }
	
	@Override
    public boolean onKeyDown (int keyCode, KeyEvent event) {
    	switch(keyCode){
    	case KeyEvent.KEYCODE_BACK:    	   	
        	Conquistadores.this.setResult(RESULT_OK);
        	Conquistadores.this.finish();
    		return true;
    	default:
    		return false;
    	}
    }
	
	public void alertConexion(int icon, String titulo, String msg){
		AlertDialog.Builder adb = new AlertDialog.Builder(this);
		adb.setMessage(msg)
    	       .setCancelable(false)
    	       .setPositiveButton(getString(R.string.botonAceptar), new DialogInterface.OnClickListener() {
    	           public void onClick(DialogInterface dialog, int id) {
    	        	   dialog.cancel();
    	           }
    	       });
    	AlertDialog alert = adb.create();
    	alert.setIcon(icon);
    	alert.setTitle(titulo);
		alert.show();
	}
}
