
package com.Conquistadores.App;

import java.util.Iterator;
import java.util.List;

import com.LibreGeoSocial.Api.Group;

/**
 * Representacin de los equipos participantes en el juego.
 * 
 * @author Fco. Javier Quero Castrillo <xavifuenla@gmail.com>
 * 
 */
public class Equipo extends Group{

	private static final long serialVersionUID = 1L;
	private int ident;
	private String color;
	private int espias;
	private int escolta;
	private Marcador marcador;
	
   	public Equipo(int ident_grupo, double latitud, double longitud, double altitud, double radio,
   			String since, String nombre, int ident, String color, int espias, int escolta, Marcador marcador){
   		super(ident_grupo, latitud, longitud, altitud, radio, since);
   		super.setGroupName(nombre);

   		this.ident = ident;
   		this.color = color;
   		this.espias = espias;
   		this.escolta = escolta;
   		this.marcador = marcador;
   	}

	public int getIdent() {
		return ident;
	}
	
	public String getColor() {
		return color;
	}
	
	public int getEspias() {
		return espias;
	}
	public void setEspias(int espias) {
		this.espias = espias;
	}

	public int getEscolta() {
		return escolta;
	}
	public void setEscolta(int escolta) {
		this.escolta = escolta;
	}
	
	public Marcador getMarcador() {
		return marcador;
	}

	public static Equipo selecionarPorId(List<Equipo> equipos, int ident){
		Equipo equipo = null;
   		boolean salir = false;
   		Iterator<Equipo> it = equipos.iterator();
		while (it.hasNext() && !salir){
			equipo = it.next();
			if (equipo.getIdent() == ident){
   				salir = true;
   			}
		}
		return equipo;
   	}
	
	public static Equipo selecionarPorNombre(List<Equipo> equipos, String nombre){
		Equipo equipo = null;
   		boolean salir = false;
   		Iterator<Equipo> it = equipos.iterator();
		while (it.hasNext() && !salir){
			equipo = it.next();
			if (equipo.getGroupName().compareTo(nombre) == 0){
   				salir = true;
   			}
		}		
   		return equipo;
   	}
}
