package com.Conquistadores.App;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

import com.Conquistadores.App.R;

/**
 * Activity que muestra los detalles del mensaje seleccionado en la lista: emisor,
 * destinatario, fecha con la que fue enviado y el cuerpo del mensaje.
 * Si el usuario lo desea, puede responder al mensaje pulsando el botn de la parte
 * inferior.
 * 
 * @author Fco. Javier Quero Castrillo <xavifuenla@gmail.com>
 * 
 */
public class MensajeDetalle extends Activity implements OnClickListener{
	
	private Button botonResponder;
	
	@Override
	public void onCreate(Bundle savedInstanceState) {
		
		super.onCreate(savedInstanceState);
        setContentView(R.layout.mensaje_detalle);
        Mensaje mensaje = MensajeListar.getMensaje();
        
        TextView textView = (TextView) this.findViewById(R.id.textEmisor);
        String str = String.format(getString(R.string.equipoEmisor), mensaje.getEmisor());
		textView.setText(str);
		
		textView = (TextView) this.findViewById(R.id.textReceptor);
		str = String.format(getString(R.string.equipoReceptor), mensaje.getReceptor());
		textView.setText(str);	
		
		textView = (TextView) this.findViewById(R.id.textFecha);
		String []camposFecha = mensaje.getFecha().split("\\.");
		str = String.format(getString(R.string.fechaMensaje), camposFecha[0]);
		textView.setText(str);	
		
		textView = (TextView) this.findViewById(R.id.textDetalleMensaje);
		textView.setText(mensaje.getTexto());	
		
		botonResponder = (Button)this.findViewById(R.id.botonResponder);		
		botonResponder.setOnClickListener(this);
	}
	
	@Override
	protected void onPause(){
		super.onPause();
		finish();
	}
	
    public void onClick(View v){    	
    	if(botonResponder.isPressed()){ 
    		Intent i = new Intent(MensajeDetalle.this, MensajeNuevo.class);
    		this.startActivity(i);
    		MensajeDetalle.this.setResult(RESULT_OK);
    		MensajeDetalle.this.finish();
    	}
    }
}
