package com.Conquistadores.App;

import com.Conquistadores.App.R;

import android.content.Context;
import android.graphics.drawable.Drawable;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ImageView;
import android.widget.TextView;

/**
 * Clase auxiliar para formar los context menu de los equipos y territorios
 * posicionados en el mapa.
 * 
 * @author Fco. Javier Quero Castrillo <xavifuenla@gmail.com>
 * 
 */
public class MenuAdapter extends ArrayAdapter<MenuFila>{
	private Context context;
	private MenuFila[] opciones;
	
	public MenuAdapter(Context context, MenuFila[] opciones) {
		super(context, R.layout.menu, opciones);
		this.context = context;
		this.opciones = opciones;
	}
	 
	public View getView(int position, View convertView, ViewGroup parent) {
		View view;
		
        if (convertView == null) {
            LayoutInflater inflater = (LayoutInflater) context.getSystemService(Context.LAYOUT_INFLATER_SERVICE);
            view = inflater.inflate(R.layout.menu, null);
        } else {
            view = convertView;
        }   
        
        ImageView icono = (ImageView) view.findViewById(R.id.icono);
        TextView titulo = (TextView) view.findViewById(R.id.titulo);
        
        Drawable drawable = context.getResources().getDrawable(opciones[position].getIcono());            
        icono.setImageDrawable(drawable);
        
        titulo.setText(opciones[position].getTitulo());
 
        return view;
	}

}
