
package com.Conquistadores.App;

import java.util.Iterator;
import java.util.List;

/**
 * Clase que implementa las partidas en la aplicacion. Tambin almacena la lista de los
 * equipos y territorios de la partida seleccionada por el usuario.
 * 
 * @author Fco. Javier Quero Castrillo <xavifuenla@gmail.com>
 * 
 */

public class Partida{
	private List<Equipo> equipos;
	private List<Territorio> territorios;

	private int ident;
  	private String nombre;
   	private String lugar;
   	private String fecha;
   	private int numEspias;
   	private int numEscolta;
   	private int duracion;
   	private String crecimiento;
   	private String descPartida;
    	
   	public Partida(int ident, String nombre, String lugar, String fecha,
   			int numEspias, int numEscolta, int duracion, String crecimiento, 
   			String descPartida){
   		
   		this.ident = ident;
   		this.nombre = nombre;
   		this.lugar = lugar;
   		this.fecha = fecha;
   		this.numEspias = numEspias;
   		this.numEscolta = numEscolta;
   		this.duracion = duracion;
   		this.crecimiento = crecimiento;
   		this.descPartida = descPartida;
   	}
   	
	public List<Equipo> getEquipos() {
		return equipos;
	}
	public void setEquipos(List<Equipo> equipos) {
		this.equipos = equipos;
	}

	public List<Territorio> getTerritorios() {
		return territorios;
	}
	public void setTerritorios(List<Territorio> territorios) {
		this.territorios = territorios;
	}
   	
   	public int getIdent() {
		return ident;
	}

	public String getTitulo() {
		return nombre;
	}

	public String getLugar() {
		return lugar;
	}

	public String getFecha() {
		return fecha;
	}
	
	public int getDuracion() {
		return duracion;
	}

	public int getNumEspias() {
		return numEspias;
	}

	public int getNumEscolta() {
		return numEscolta;
	}
	
	public String getCrecimiento() {
		return crecimiento;
	}

	public String getDescPartida() {
		return descPartida;
	}

	public static Partida selecionarPorId(List<Partida> partidas, int ident){
   		Partida partida = null;
   		boolean salir = false;
   		Iterator<Partida> it = partidas.iterator();
		while (it.hasNext() && !salir){
			partida = it.next();
			if (partida.getIdent() == ident){
   				salir = true;
   			}
		}
		return partida;
	}
}
