package com.Conquistadores.App;

import com.Conquistadores.App.R;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.view.View;
import android.view.View.OnClickListener;
import android.widget.Button;
import android.widget.TextView;

/**
 * ltima pantalla antes de empezar el juego. Se muestra un texto con el nombre de la
 * partida y equipo seleccionado por el usuario, junto con la descripcin de la partida.
 * Si el jugador est conforme, pulsa el botn y comienza la partida.
 * 
 * @author Fco. Javier Quero Castrillo <xavifuenla@gmail.com>
 * 
 */
public class PartidaEmpezar extends Activity implements OnClickListener{
	private Button botonEmpezar;
	
    @Override
    public void onCreate(Bundle savedInstanceState){
        super.onCreate(savedInstanceState);
        setContentView(R.layout.partida_empezar);
        
        String texto = String.format(getString(R.string.textoEmpezar), PartidaListar.getPartida().getTitulo(), RecursoListar.getEquipo().getGroupName(), PartidaListar.getPartida().getDescPartida());
        TextView textoEmpezar = (TextView) this.findViewById(R.id.textoEmpezar);
        textoEmpezar.setText(texto);
		
        botonEmpezar = (Button)this.findViewById(R.id.botonEmpezar);		
        botonEmpezar.setOnClickListener(this);
    }
       
    public void onClick(View v){    	
    	if(botonEmpezar.isPressed()){ 
    		Intent intent = new Intent(PartidaEmpezar.this, TabHostPartida.class);
    		this.startActivity(intent);
    		intent = new Intent(PartidaEmpezar.this, ServicioLocalizacion.class);
    		this.startService(intent);
    		intent = new Intent(PartidaEmpezar.this, ServicioRecursoEquipo.class);
    		this.startService(intent);
    		intent = new Intent(PartidaEmpezar.this, ServicioMensajeria.class);
    		this.startService(intent);
    		intent = new Intent(PartidaEmpezar.this, ServicioEnfrentamiento.class);
    		this.startService(intent);

			PartidaEmpezar.this.setResult(RESULT_OK);
			PartidaEmpezar.this.finish();
    	}
    }
}
