
package com.Conquistadores.App;

import java.util.List;

import com.LibreGeoSocial.Api.GeoNode;

/**
 * Clase que implementa los territorios en la aplicacion.
 * 
 * @author Fco. Javier Quero Castrillo <xavifuenla@gmail.com>
 * 
 */
public class Territorio extends GeoNode{

	private static final long serialVersionUID = 1L;
	private String nombre;
	private int equipoPoseedorId;
	private String color;
    	
   	public Territorio(int ident, double latitud, double longitud, double altitud, double radio,
   			String since, String nombre, int equipoPoseedorId, String color){
   		super(ident, latitud, longitud, altitud, radio, since, null);

   		this.nombre = nombre;
   		this.equipoPoseedorId = equipoPoseedorId;
   		this.color = color;
   	}
   	
	public String getNombre() {
		return nombre;
	}
	
	public int getEquipoPoseedorId() {
		return equipoPoseedorId;
	}	
	public void setEquipoPoseedorId(int equipoPoseedorId) {
		this.equipoPoseedorId = equipoPoseedorId;
	}
	
	public String getColor() {
		return color;
	}
	public void setColor(String color) {
		this.color = color;
	}

	public static Territorio selecionarPorId(List<Territorio> territorios, int ident){
   		Territorio territorio = null;	
   		for (int i = 0; i <= territorios.size(); i++){
   			if (territorios.get(i).getId() == ident){
   				territorio = territorios.get(i);
   				break;
   			}
   		}
   		return territorio;
   	}
	
	public static Territorio selecionarPorNombre(List<Territorio> territorios, String nombre){
   		Territorio territorio = null;	
   		for (int i = 0; i <= territorios.size(); i++){
   			if (territorios.get(i).getNombre().compareTo(nombre) == 0){
   				territorio = territorios.get(i);
   				break;
   			}
   		}
   		return territorio;
   	}
	
}
