from apps.conquistadores.models import *
from social.core import api as api_lgs
from apps.conquistadores.core import lib_duelo
from django.db.models import F
from django.db.models import Q

def crear(nombre, color, partida):
    grupo = {'groupname': nombre}
    correcto, resultado = api_lgs.group.create_or_modify(grupo, modify=False)
    if correcto:
        grupo = Group.objects.get(id=resultado)
        equipo = Equipo()
        equipo.grupo = grupo
        equipo.partida = partida
        equipo.color = color.nombre
        equipo.espias = partida.espias
        equipo.escolta = partida.escolta
        equipo.save()
        color.delete()

        marcador = Marcador()
        marcador.partida = partida
        marcador.equipo = equipo
        marcador.puntuacion = 0
        marcador.num_territorios = 0
        marcador.save()
        return True, equipo
    else:
        return False, "El equipo '" + nombre + "' ya existe."

def modificar(nombre, equipo):
    try:
        nombre_aux = equipo.grupo.name
        equipo.grupo.name = nombre
        equipo.grupo.save()
        equipo.save()
        return True, equipo
    except:
        return False, 'Error al modificar el equipo '+ nombre_aux

def modificar_posicion(posicion, equipo):
    equipo.grupo.position = posicion
    equipo.grupo.save()
    equipo.save()    
 
def modificar_por_partida(espias, escolta, equipo):
    equipo.espias = espias
    equipo.escolta = escolta
    equipo.save()
    return equipo

def modificar_espias(partida, equipo):
    try:
        updated = partida.equipo_set.filter(Q(id=equipo.id) & Q(espias__gt=0))\
                  .update(espias=F('espias') - 1,
                          version=F('version') + 1)
        if updated:
            return True, 'ok'
        else:
            return False, 'no espias'
    except:
        return False, 'El equipo con dicho identificador no se pudo encontrar.'

def modificar_recursos(partida, equipo_id, crecimiento, puntuacion):
    try:
        partida.equipo_set.filter(id=equipo_id).update(escolta=F('escolta') + crecimiento,
                                                       version = F('version') + 1)
        partida.territorio_set.filter(equipo__id=equipo_id).update(version = F('version') + 1)
        Tropa.objects.filter(territorio__equipo__id=equipo_id).update(cantidad = F('cantidad') + crecimiento)
        
        partida.marcador_set.filter(equipo__id=equipo_id).update(puntuacion = F('puntuacion') + (F('num_territorios')*puntuacion))
        return True, 'ok'
    except:
        return False, 'El equipo con dicho identificador no se pudo encontrar.'
    
def eliminar(equipo, id_usuario):        
    marcadores = equipo.marcador_set.all()
    for marcador in marcadores:
        marcador.delete()
    color = Color(nombre=equipo.color, partida=equipo.partida)
    color.save()
    equipo.territorio_set.filter(equipo__id=equipo.id)\
                  .update(equipo=None)
    equipo.delete()
    equipo.grupo.delete(id_usuario)

def obtener(partida, equipo_id):
    try:    
        equipo = partida.equipo_set.get(id=equipo_id)
        return True, equipo
    except:
        return False, 'El equipo con dicho identificador no se pudo encontrar.'

def listar_completo(partida):
    return partida.equipo_set.all().order_by('id')

def duelo(partida, equipo_ganador_id, defensor_version, atacante_version, atac_escolta_final, def_escolta_final,
          equipo_atacante, equipo_defensor, puntuacion):
    try:
        updated_atac = partida.equipo_set.filter(Q(id=equipo_atacante.id) & Q(version=atacante_version))\
                       .update(version=F('version') + 1, escolta = atac_escolta_final)
        if updated_atac:
            updated_def = partida.equipo_set.filter(Q(id=equipo_defensor.id) & Q(version=defensor_version))\
                          .update(version=F('version') + 1, escolta = def_escolta_final)
            if updated_def:
                partida.marcador_set.filter(equipo__id=equipo_ganador_id).update(puntuacion = F('puntuacion') + puntuacion)
            else:
                equipo_atacante.save()
                return False, 'version diferente'
        else:
            return False, 'version diferente'

        lib_duelo.crear(equipo_atacante, equipo_defensor, equipo_ganador_id)
        return True, 'ok'
    except:
        return False, 'No existe el objeto con ese identificador'
