from apps.conquistadores.models import *

def crear(tipo_emisor, tipo_recp, emisor, receptor, texto, partida):
    mensaje = Mensaje()
    mensaje.partida = partida
    mensaje.save()
    
    #Mensaje enviado por un organizador
    if tipo_emisor == "organizador": 
        mensaje.desde_organizador = emisor
        #Mensaje org -> 1 equipo
        if tipo_recp == "unico": 
            mensaje.a_equipo.add(receptor)
        #Mensaje org -> n equipos
        else: 
            receptores = partida.equipo_set.all()
            for receptor in receptores:
                mensaje.a_equipo.add(receptor)
    else:
        mensaje.desde_equipo = emisor
        if tipo_recp == "organizador":
            mensaje.a_organizador = receptor
        else:
            mensaje.a_equipo.add(receptor)
            
    mensaje.texto = texto
    mensaje.save()
    return mensaje

def eliminar(mensaje): 
    mensaje.delete()

def obtener(partida, mensaje_id):
    try:    
        mensaje = partida.mensaje_set.get(id=mensaje_id)
        return True, mensaje
    except:
        return False, "El mensaje con dicho identificador no se pudo obtener."

def obtener_id(mensaje):
    return mensaje.id
    
def listar_tipo(partida, equipo_id, pet_mensaje):
    if pet_mensaje == 'r':
        mensajes = partida.mensaje_set.filter(a_equipo__id=equipo_id).order_by('-date')
    else:
        mensajes = partida.mensaje_set.filter(desde_equipo__id=equipo_id).order_by('-date')
    return mensajes

def listar_completo(partida):
    return partida.mensaje_set.all().order_by('-date')
