from apps.conquistadores.models import *

def crear(titulo, lugar, fecha, duracion, espias, escolta, crecimiento, descripcion, usuario_id):
    partida = Partida()
    partida.titulo = titulo
    partida.lugar = lugar
    partida.fecha = fecha
    partida.duracion = duracion
    partida.espias = espias
    partida.escolta = escolta
    partida.crecimiento = crecimiento
    partida.descripcion = descripcion
    partida.save()

    #user = Person.objects.get(id=manager_id)
    persona = Person.objects.get(id=usuario_id)
    organizador = Organizador.objects.get(usuario=persona)
    organizador.partidas.add(partida)
    organizador.save()

    return partida

def modificar(titulo, lugar, fecha, duracion, espias, escolta, crecimiento, descripcion, partida):
    partida.titulo = titulo
    partida.lugar = lugar
    partida.fecha = fecha
    partida.duracion = duracion
    partida.espias = espias
    partida.escolta = escolta
    partida.crecimiento = crecimiento
    partida.descripcion = descripcion
    partida.save()

    return partida

def eliminar(partida, id_usuario): #borrar la partida y todo lo que dependa de ella
    colores = partida.color_set.all()
    for color in colores:
        color.delete()
    conquistas = Conquista.objects.filter(atacante__partida=partida)
    for conquista in conquistas:
        conquista.delete()
    territorios = partida.territorio_set.all()
    for territorio in territorios:
        tropas = territorio.tropa_set.all()
        for tropa in tropas:
            tropa.delete()
        territorio.delete(id_usuario)
    mensajes = partida.mensaje_set.all()
    for mensaje in mensajes:
        mensaje.delete()
    duelos = Duelo.objects.filter(atacante__partida=partida)
    for duelo in duelos:
        duelo.delete()
    equipos = partida.equipo_set.all()
    for equipo in equipos:
        marcadores = equipo.marcador_set.all()
        for marcador in marcadores:
            marcador.delete()
        equipo.delete()
        equipo.grupo.delete(id_usuario)
    partida.delete()

def cambiar_estado(partida):
    if partida.cerrado:
      partida.cerrado = False
    else:
      partida.cerrado = True
    partida.save()
    return partida

def obtener(partida_id):
    try:
        partida = Partida.objects.get(id=partida_id)
        return True, partida
    except:
        return False, "La partida con dicho identificador no se pudo obtener."

def listar_completo():
    return Partida.objects.all().order_by('fecha')

def listar_organizador(id_usuario):
    try:
        persona = Person.objects.get(id=id_usuario)
        partidas = Organizador.objects.get(usuario=persona).partidas.all().order_by('fecha')
        return True, partidas
    except:
        return False, "No se encuentran partidas creadas por este organizador."
