from apps.conquistadores.models import *
from apps.conquistadores.core import lib_conquista
from django.db.models import F
from django.db.models import Q

def crear(nombre, posicion, partida):
    territorio = Territorio()
    territorio.nombre = nombre
    territorio.position = posicion
    territorio.partida = partida
    territorio.save()
    
    return territorio

def eliminar(territorio, id_usuario): 
    tropas = territorio.tropa_set.all()
    for tropa in tropas:
        tropa.delete()
    territorio.delete(id_usuario)

def modificar(nombre, posicion, territorio):
    territorio.nombre = nombre
    territorio.position = posicion
    territorio.save()

    return territorio

def comparar_propietario(territorio, equipo_id):
    return territorio.equipo.id == int(equipo_id)

def obtener(partida, territorio_id):
    try:    
        territorio = partida.territorio_set.get(id=territorio_id)
        return True, territorio
    except:
        return False, "El territorio con dicho identificador no se pudo obtener."

def obtener_por_equipo(equipo):    
    return equipo.territorio_set.all().order_by('id')

def listar_completo(partida):
    return partida.territorio_set.all().order_by('id')

def conquistar_vacio(partida, territorio_id, marcador, puntuacion):
    try:
        updated = partida.territorio_set.filter(Q(id=territorio_id) & Q(equipo=None))\
                  .update(equipo=marcador.equipo,
                          version=F('version') + 1)
        if updated:
            marcador.puntuacion = F('puntuacion') + puntuacion
            marcador.num_territorios = F('num_territorios') + 1
            marcador.save()
            return True, 'ok'
        else:
            return False, 'version diferente'        
    except:
        return False, 'No existe el objeto con ese identificador'
    
def conquistar_rival(partida, equipo_ganador_id, version_atacante, version_defensor, tropa_defensiva, num_tropa_atac_inic,
                     num_tropa_atac_final,num_tropa_def_final, marcador_atacante, marcador_defensor, puntuacion):
    #try:
        #El equipo ganador es el atacante
        if equipo_ganador_id == marcador_atacante.equipo.id:
            updated_atac = partida.equipo_set.filter(Q(id=marcador_atacante.equipo.id) & Q(version=version_atacante))\
                           .update(version=F('version') + 1,
                                   escolta=F('escolta') - num_tropa_atac_inic)
            if updated_atac:
                updated_def = partida.territorio_set.filter(Q(id=tropa_defensiva.territorio.id) & Q(version=version_defensor))\
                              .update(equipo=marcador_atacante.equipo,
                                      version=F('version') + 1)
                if updated_def:
                    marcador_defensor.equipo.version = F('version') + 1
                    marcador_defensor.equipo.espias = F('espias')
                    marcador_defensor.equipo.escolta=F('escolta') + num_tropa_def_final
                    marcador_defensor.equipo.save()
                    marcador_defensor.puntuacion = F('puntuacion')
                    marcador_defensor.num_territorios = F('num_territorios') - 1
                    marcador_defensor.save()
                    
                    tropa_defensiva.cantidad = num_tropa_atac_final
                    tropa_defensiva.save()
                    marcador_atacante.puntuacion = F('puntuacion') + puntuacion
                    marcador_atacante.num_territorios = F('num_territorios') + 1
                    marcador_atacante.save()
                else:
                    marcador_atacante.equipo.save()
                    return False, 'version diferente'
            else:
                return False, 'version diferente'
        else:
            updated_atac = partida.equipo_set.filter(Q(id=marcador_atacante.equipo.id) & Q(version=version_atacante))\
                           .update(version=F('version') + 1,
                                   escolta=F('escolta') - num_tropa_atac_inic + num_tropa_atac_final)
            if updated_atac:
                updated_def = partida.territorio_set.filter(Q(id=tropa_defensiva.territorio.id) & Q(version=version_defensor))\
                              .update(version=F('version') + 1)
                if updated_def:
                    tropa_defensiva.cantidad = num_tropa_def_final
                    tropa_defensiva.save()                    
                else:
                    marcador_atacante.equipo.save()
                    return False, 'version diferente'
            else:
                return False, 'version diferente'
            
        lib_conquista.crear(marcador_atacante.equipo, marcador_defensor.equipo, tropa_defensiva.territorio, equipo_ganador_id)
        return True, 'ok'
    #except:
    #   return False, 'No existe el objeto con ese identificador'
