from apps.conquistadores.models import *
from django.db.models import F
from django.db.models import Q

def crear(tipo, cantidad, territorio):
    tropa = Tropa()
    tropa.territorio = territorio
    #tropa.partida = partida
    tropa.tipo = tipo
    tropa.cantidad = cantidad
    tropa.save()

    return tropa

def modificar(tipo, cantidad, tropa):
    tropa.tipo = tipo
    tropa.cantidad = cantidad
    tropa.save()

    return tropa

def eliminar(tropa): 
    tropa.delete()

def obtener(territorio, tropa_id):
    try:    
        tropa = territorio.tropa_set.get(id=tropa_id)
        return True, tropa
    except:
        return False, "La tropa con dicho identificador no se pudo obtener."

def obtener_por_territorio(territorio):
    return territorio.tropa_set.all().order_by('id')

def obtener_por_equipo(equipo):
    return Tropa.objects.filter(territorio__equipo=equipo).order_by('id')

def listar_completo(partida):
    return Tropa.objects.filter(territorio__partida=partida).order_by('id')

def mover (partida, tipo_origen, origen_version, destino_version, num_tropa_origen, tipo_destino, origen, destino):
    #Movimiento de tropas entre equipo->territorio
    try:
        if tipo_origen == "equipo":
            equipo=origen
            tropa=destino

            updated_dest = partida.territorio_set.filter(Q(id=tropa.territorio.id) & Q(version=destino_version))\
                           .update(version=F('version') + 1)
            if updated_dest:
                updated_orig = partida.equipo_set.filter(Q(id=equipo.id) & Q(version=origen_version))\
                               .update(version=F('version') + 1,
                                       escolta=F('escolta') - num_tropa_origen)
                if updated_orig:
                    tropa.cantidad = F('cantidad') + num_tropa_origen
                    tropa.save()
                else:
                    return False, 'version diferente'
            else:
                return False, 'version diferente'

        #Movimiento de tropas entre territorio->equipo
        else:
            tropa=origen
            updated_orig = partida.territorio_set.filter(Q(id=tropa.territorio.id) & Q(version=origen_version))\
                           .update(version=F('version') + 1)
            if not updated_orig:
                return False, 'version diferente'
            if tipo_destino == "equipo":
                equipo=destino            
                updated_dest = partida.equipo_set.filter(Q(id=equipo.id) & Q(version=destino_version))\
                               .update(version=F('version') + 1,
                                       escolta = F('escolta') + num_tropa_origen)
                if updated_dest:
                    tropa.cantidad = F('cantidad') - num_tropa_origen
                    tropa.save()
                else:
                    return False, 'version diferente'
                    
            #Movimiento de tropas entre territorio->territorio
            else:
                tropa2=destino
                updated_dest = partida.territorio_set.filter(Q(id=tropa2.territorio.id) & Q(version=destino_version))\
                               .update(version=F('version') + 1)
                if updated_dest:
                    tropa.cantidad = F('cantidad') - num_tropa_origen
                    tropa.save()
                    tropa2.cantidad = F('cantidad') + num_tropa_origen
                    tropa2.save()
                else:
                    return False, 'version diferente'
        return True, 'ok'
    except:
        return False, 'No existe el objeto con ese identificador' 
        
