from django.conf.urls.defaults import *
from apps.conquistadores.rest import views

STATICFILES_DIRS = 'C:/PFC/LibreGeoSocial/apps/conquistadores/'

urlpatterns = patterns('',
    #Patrones para servir ficheros estaticos
    (r'ficheros/(?P<path>.*)$', 'django.views.static.serve', {'document_root': STATICFILES_DIRS+'templates'}),
    (r'imagenes/(?P<path>.*)$', 'django.views.static.serve', {'document_root': STATICFILES_DIRS+'templates/imagenes'}),

    #Patrones de la aplicacion conquistadores
    (r'^$', 'apps.conquistadores.rest.views.usr_partida_listar'),
    (r'^usuario/login/$', 'apps.conquistadores.rest.views.login_usuario'),
    (r'^usuario/logout/$', 'apps.conquistadores.rest.views.logout_usuario'),
    (r'^inicio/$', 'apps.conquistadores.rest.views.usr_partida_listar'),

    (r'^partida/crear/$', 'apps.conquistadores.rest.views.partida_crear'),
    (r'^partida/listar/$', 'apps.conquistadores.rest.views.partida_listar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/cambiar_estado/$', 'apps.conquistadores.rest.views.partida_cambiarEstado'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/eliminar/$', 'apps.conquistadores.rest.views.partida_eliminar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/info/$', 'apps.conquistadores.rest.views.partida_info'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/modificar/$', 'apps.conquistadores.rest.views.partida_modificar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/seguimiento/$', 'apps.conquistadores.rest.views.partida_seguimiento'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/recurso/listar/$', 'apps.conquistadores.rest.views.partida_recurso_listar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/estadisticas/(?P<equipo_id>[1-9][0-9]*)/$', 'apps.conquistadores.rest.views.partida_estadisticas'),
               
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/crear/$', 'apps.conquistadores.rest.views.equipo_crear'),                       
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/eliminar/$', 'apps.conquistadores.rest.views.equipo_eliminar'),                       
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/info/$', 'apps.conquistadores.rest.views.equipo_info'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/modificar/$', 'apps.conquistadores.rest.views.equipo_modificar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/listar/$', 'apps.conquistadores.rest.views.equipo_listar'),    
                       
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/territorio/crear/$', 'apps.conquistadores.rest.views.territorio_crear'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/territorio/(?P<territorio_id>[1-9][0-9]*)/eliminar/$', 'apps.conquistadores.rest.views.territorio_eliminar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/territorio/(?P<territorio_id>[1-9][0-9]*)/info/$', 'apps.conquistadores.rest.views.territorio_info'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/territorio/listar/$', 'apps.conquistadores.rest.views.territorio_listar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/territorio/(?P<territorio_id>[1-9][0-9]*)/modificar/$', 'apps.conquistadores.rest.views.territorio_modificar'),

    (r'^partida/(?P<partida_id>[1-9][0-9]*)/mensaje/crear/$', 'apps.conquistadores.rest.views.mensaje_crear'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/mensaje/(?P<pet_mensaje>r|e)/listar/$', 'apps.conquistadores.rest.views.equipo_mensaje_listar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/mensaje/(?P<mensaje_id>[1-9][0-9]*)/eliminar/$', 'apps.conquistadores.rest.views.mensaje_eliminar'),

    #URLS que identifican las acciones en el juego de un equipo con otro recurso(territorio y/o equipo)
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/territorio/(?P<territorio_id>[1-9][0-9]*)/conquistar/$', 'apps.conquistadores.rest.views.equipo_territorio_conquistar'),                       
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/territorio/(?P<territorio_id>[1-9][0-9]*)/info/$', 'apps.conquistadores.rest.views.equipo_territorio_info'),  
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/territorio/(?P<territorio_id>[1-9][0-9]*)/espiar/$', 'apps.conquistadores.rest.views.equipo_territorio_espiar'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/(?P<tipo_destino>territorio|equipo)/(?P<destino_id>[1-9][0-9]*)/tropa/mover/$', 'apps.conquistadores.rest.views.equipo_tropa_mover'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_atac_id>[1-9][0-9]*)/equipo/(?P<equipo_def_id>[1-9][0-9]*)/duelo/$', 'apps.conquistadores.rest.views.equipo_duelo'),                        
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/conquista/(?P<conquista_id>[0-9]+)/duelo/(?P<duelo_id>[0-9]+)/listar/$', 'apps.conquistadores.rest.views.enfrentamiento_listar'),              
                             
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/servicio/mapa/$', 'apps.conquistadores.rest.views.servicio_mapa'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/servicio/mensajeria/$', 'apps.conquistadores.rest.views.servicio_mensajeria'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/servicio/localizacion/$', 'apps.conquistadores.rest.views.servicio_localizacion'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/servicio/recursos/$', 'apps.conquistadores.rest.views.servicio_recursos'),
    (r'^partida/(?P<partida_id>[1-9][0-9]*)/equipo/(?P<equipo_id>[1-9][0-9]*)/servicio/enfrentamiento/$', 'apps.conquistadores.rest.views.servicio_enfrentamiento')                      ,
)
