#!/bin/bash
#
# LibreGeoSocial server configurator
# by Juan Francisco Gato Luis <jfcogato@libresoft.es>
# GSyC / LibreSoft

HOST="mylgs.com"
SETTINGS="/var/www/libregeosocial/settings.py"


cd /var/www/
chown -R www-data:www-data libregeosocial/

#creating BBDD
echo "--creating bbdd--"
su postgres -c "psql -U postgres -d template1 < /var/www/libregeosocial/lgs_db.sql"

#new password to psql's postgres user
echo "--postgres password (postgres): --"
su postgres -c "psql -U postgres -c '\password postgres'"

#Configure correctly the settings.py
echo "--configuring settings.py--"
cat ${SETTINGS} | sed s/DATABASE_ENGINE.*$/DATABASE_ENGINE=\'\postgresql_psycopg2\'/ |
          sed s/DATABASE_NAME.*$/DATABASE_NAME=\'\social\'/ |
          sed s/DATABASE_USER.*$/DATABASE_USER=\'\postgres\'/ |
          sed s/DATABASE_PASSWORD.*$/DATABASE_PASSWORD=\'\postgres\'/ |
          sed s/DATABASE_HOST.*$/DATABASE_HOST=\'\localhost\'/ |
          sed s/DATABASE_PORT.*$/DATABASE_PORT=\'\'/  > /tmp/settings.py
mv /tmp/settings.py ${SETTINGS}

#configurate the BBDD
su postgres -c "python /var/www/libregeosocial/manage.py syncdb"

#configuring ssl (https access)
a2enmod ssl
cd /etc/apache2/
openssl genrsa -des3 -out server.key 1024
openssl req -new -key server.key -out server.csr
openssl x509 -req -days 365 -in server.csr -signkey server.key -out server.crt

#Enable rewrite module in apache
echo "--configuring apache--"
cd /etc/apache2/mods-available
a2enmod rewrite

#configuring the host in apache files
cp /var/www/libregeosocial/conf_apache/002-test.libregeosocial.libresoft.es /etc/apache2/sites-available/002-${HOST}
cat /etc/apache2/sites-available/002-${HOST} | sed -e s/test.libregeosocial.libresoft.es/${HOST}/ > /tmp/lgs-host
mv /tmp/lgs-host /etc/apache2/sites-available/002-${HOST}

cp /var/www/libregeosocial/conf_apache/003-https.test.libregeosocial.libresoft.es /etc/apache2/sites-available/003-https.${HOST}
cat /etc/apache2/sites-available/003-https.${HOST} | sed -e s/test.libregeosocial.libresoft.es/${HOST}/ > /tmp/lgs-host
mv /tmp/lgs-host /etc/apache2/sites-available/003-https.${HOST}

#Enabled the virtual sites
cd /etc/apache2/sites-available
a2ensite 002-${HOST}
a2ensite 003-https.${HOST}
/etc/init.d/apache2 restart

#launch LayerConsistency
cd /var/www/libregeosocial
python Consistency.py

#su postgres
su postgres -c "psql -U postgres social < pl_functions.sql"
echo "--finished!!--"
